## ros-humble-rmf-traffic-editor 1.6.2

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.10.0)

if(NOT CMAKE_CXX_STANDARD)
  set(CMAKE_CXX_STANDARD 17)
endif()

project(rmf_traffic_editor)

find_package(ament_cmake REQUIRED)
find_package(ament_index_cpp REQUIRED)
find_package(Ceres REQUIRED)
find_package(Eigen3 REQUIRED)
find_package(Qt5 COMPONENTS Widgets Concurrent Test Network REQUIRED)
find_package(yaml-cpp REQUIRED)

set(CMAKE_BUILD_TYPE RelWithDebInfo)
# set(CMAKE_VERBOSE_MAKEFILE TRUE)

set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -Wshadow -Wextra")

set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTORCC ON)
set(CMAKE_AUTOUIC ON)

if(CMAKE_VERSION VERSION_LESS "3.7.0")
  set(CMAKE_INCLUDE_CURRENT_DIR ON)
endif()

include_directories(.)
include_directories(gui)
include_directories(include)

set(gui_sources
  gui/actions/add_constraint.cpp
  gui/actions/add_edge.cpp
  gui/actions/add_feature.cpp
  gui/actions/add_fiducial.cpp
  gui/actions/add_model.cpp
  gui/actions/add_polygon.cpp
  gui/actions/add_property.cpp
  gui/actions/add_vertex.cpp
  gui/actions/delete.cpp
  gui/actions/move_feature.cpp
  gui/actions/move_fiducial.cpp
  gui/actions/move_model.cpp
  gui/actions/move_vertex.cpp
  gui/actions/polygon_remove_vertices.cpp
  gui/actions/polygon_add_vertex.cpp
  gui/actions/rotate_model.cpp
  gui/add_param_dialog.cpp
  gui/building.cpp
  gui/building_dialog.cpp
  gui/constraint.cpp
  gui/coordinate_system.cpp
  gui/feature.cpp
  gui/edge.cpp
  gui/editor.cpp
  gui/editor_model.cpp
  gui/fiducial.cpp
  gui/graph.cpp
  gui/layer.cpp
  gui/layer_dialog.cpp
  gui/layer_table.cpp
  gui/level.cpp
  gui/level_dialog.cpp
  gui/level_table.cpp
  gui/lift.cpp
  gui/lift_dialog.cpp
  gui/lift_door.cpp
  gui/lift_table.cpp
  gui/map_tile_cache.cpp
  gui/map_view.cpp
  gui/model.cpp
  gui/model_dialog.cpp
  gui/param.cpp
  gui/polygon.cpp
  gui/preferences_dialog.cpp
  gui/preferences_keys.cpp
  gui/rendering_options.cpp
  gui/table_list.cpp
  gui/traffic_table.cpp
  gui/traffic_map.cpp
  gui/transform.cpp
  gui/vertex.cpp
  gui/yaml_utils.cpp

  #crowd_sim related
  gui/multi_select_combo_box.cpp
  gui/crowd_sim/agent_group.cpp
  gui/crowd_sim/agent_group_table.cpp
  gui/crowd_sim/agent_profile.cpp
  gui/crowd_sim/agent_profile_table.cpp
  gui/crowd_sim/condition.cpp
  gui/crowd_sim/condition_dialog.cpp
  gui/crowd_sim/crowd_sim_dialog.cpp
  gui/crowd_sim/crowd_sim_editor_table.cpp
  gui/crowd_sim/crowd_sim_impl.cpp
  gui/crowd_sim/crowd_sim_table_base.cpp
  gui/crowd_sim/goal_set.cpp
  gui/crowd_sim/goal_set_table.cpp
  gui/crowd_sim/model_type.cpp
  gui/crowd_sim/model_type_table.cpp
  gui/crowd_sim/state.cpp
  gui/crowd_sim/state_table.cpp
  gui/crowd_sim/to_state_dialog.cpp
  gui/crowd_sim/to_state_table.cpp
  gui/crowd_sim/transition.cpp
  gui/crowd_sim/transition_table.cpp
)

add_library(
  gui_lib STATIC
  ${gui_sources})

target_link_libraries(
  gui_lib
  ament_index_cpp::ament_index_cpp
  ceres
  Eigen3::Eigen
  Qt5::Widgets
  Qt5::Concurrent
  Qt5::Network
  proj
  yaml-cpp
  ${ament_index_cpp_LIBRARIES}
)

add_executable(
  traffic-editor
  resources/resource.qrc
  gui/main.cpp)

target_link_libraries(traffic-editor gui_lib)

set_property(TARGET traffic-editor PROPERTY ENABLE_EXPORTS 1)

install(
  TARGETS traffic-editor
  LIBRARY DESTINATION lib
  RUNTIME DESTINATION bin
)

install(
  DIRECTORY
    plugins
  DESTINATION
    include/traffic_editor)

install(
  DIRECTORY
    include/traffic_editor
  DESTINATION
    include)

if (BUILD_TESTING)
  find_package(ament_cmake_uncrustify REQUIRED)
  find_package(rmf_utils REQUIRED)

  add_subdirectory(test)

  find_file(uncrustify_config_file
    NAMES "rmf_code_style.cfg"
    PATHS
      "${rmf_utils_DIR}/../../../share/rmf_utils/"
      "/opt/ros/galactic/share/rmf_utils")

  ament_uncrustify(
    ARGN include gui
    CONFIG_FILE ${uncrustify_config_file}
    MAX_LINE_LENGTH 80
    LANGUAGE CPP
  )
endif()

ament_export_include_directories(include)

ament_package()

=== debian/changelog ===
ros-humble-rmf-traffic-editor (1.6.2-1bookworm) bookworm; urgency=high



 -- Morgan Quigley <morgan@openrobotics.org>  Wed, 09 Aug 2023 16:00:00 -0000

ros-humble-rmf-traffic-editor (1.6.1-1bookworm) bookworm; urgency=high

  * Switch changelogs to rst format.
  * Contributors: Yadunund

 -- Morgan Quigley <morgan@openrobotics.org>  Sun, 04 Jun 2023 16:00:00 -0000

ros-humble-rmf-traffic-editor (1.6.0-1bookworm) bookworm; urgency=high

  * Added a dispensable field for models (#436 <https://github.com/open-rmf/rmf_traffic_editor/pull/436>)
  * Use index based iterator to avoid yaml cpp bug (#435 <https://github.com/open-rmf/rmf_traffic_editor/pull/435>)
  * better vertex text size in meter-scale maps (#431 <https://github.com/open-rmf/rmf_traffic_editor/pull/431>)
  * Contributors: Aaron Chong, Luca Della Vedova, Morgan Quigley

 -- Morgan Quigley <morgan@openrobotics.org>  Tue, 04 Oct 2022 16:00:00 -0000

ros-humble-rmf-traffic-editor (1.5.1-1bookworm) bookworm; urgency=high

  * update OSM tile server URL to full planet data (#430)
  * fix cmake ament_index_cpp dependency
  * add a github CI job for rolling
  * don't double-trigger CI runs
  * update qt packages for jammy github workflow
  * build/install rmf_utils from source in ci_rolling
  * Contributors: Morgan Quigley, Youliang Tan

 -- Morgan Quigley <morgan@openrobotics.org>  Tue, 19 Apr 2022 16:00:00 -0000

ros-humble-rmf-traffic-editor (1.5.0-1bookworm) bookworm; urgency=high

  * fix #419 by calculating transformed x/y in image-based maps (#421)
  * validate reference level index before using it (avoid a crash)
  * Use C++17 for std::optional
  * move all CI to galactic on ubuntu 20.04
  * move the C++ style check into the 'main' CI test workflow
  * Feature/render OpenStreetMap tiles (#418)
    * "new building" dialog box which asks which coordinates to use
    * use a subdirectory in ~/.cache as the OSM tile cache
    * show the tile cache size on the status bar
    * use EPSG:3857 (meters) for rendering tile maps
    * WGS84 coordinate translation
    * render OSM tiles in grayscale, so the non-tile things are easier to see
    * populate lat, lon property fields in EPSG:3857 mode
    * remove obsolete "flattened" UI stuff
    * save global coords in wgs84 but render them in epsg3857 on OSM tiles
    * GUI box to set the local CRS for sim/nav generation
    * move all RMF keys into GeoJSON props. add start/end names
    * feature_type -> rmf_type in GeoJSON properties
    * translate robot spawn point along with the world
  * Handle simulation offsets for models and cameras (#408)
    * lat/lon translation behavior for models (previously, builds break when adding models due to WGS84 translation not having a "rotation" variable)
    * change naming for wgs84 model positions to lat/lon instead of x/y for consistency
    * apply offsets to the camera, so the camera view appears over the working area
    * Handle simulation offsets for models and cameras
    * Pass transform in Model constructor; pass un-transformed variables for to_yaml
    * Add check if global_transform was initialized; fix wrong computation of xy
    * parse model coordinates in wgs84 and project for viewing/editing
    * move model projection/translation to generate phase
    * set user-agent string in HTTP tile requests
    * workaround for 32-bit scrollbar overflow at extreme zoom
    * introduce a simple queuing system for tiles
    * reset zoom when loading a different filename
  * flip layer images right-side up in cartesian meters mode (#405)
  * Improve behavior for Cartesian maps (#401)
    * Improve behavior for Cartesian maps
    * because Cartesian maps have 1-meter units, we need to compute
    a better default scale for them. Previously it was always using
    a default scale of 0.05.
    * somewhat related, also fix the edge-select implementation so it
    spins through all edges in the map rather than just selecting
    the first edge within 10 units... that was OK when we were always
    using pixel-based maps, but now that meter-based maps are in use,
    it was just choosing the first edge that was within 10 meters of
    the click, which was a lot of edges and felt somewhat random.
    * stop drawing a 1-unit border around the scene rectangle
    * rotate vertex icons to +Y for cartesian maps
  * Cartesian worlds (y=up) and steps towards using GeoPackage (#396)
    * create passthrough transform for cartesian_meters coordinate systems
    * y-flip in traffic-editor GUI for cartesian worlds; only invert Y coordinate for legacy image-based maps
    * add coordinate system files for C++ GUI
    * pass coordinate system to vertex draw, to flip text as needed
    * correct deprecated setuptools key to fix warning
    * Fix errors when building maps with lifts / crowdsim
    * draw fewer arrowheads for increased speed on very large maps
    * add speed limit parameter to lane property-editor GUI
    * add speed limit param to generated nav-graph files
    * publish lane speed limits
    * add top-level metadata for building/site params
    * load/save top level building params. Zoom->reset to center map view if you get lost.
    * assign a nonsense CRS if one doesn't exist
    * Change Legacy -> ReferenceImage throughout code
  * minor usability enhancements on traffic editor (#398)
    * revert lift vertex, and prevent delete of lift vertex
    * fix wall transparency models and update readme
  * Contributors: Morgan Quigley, Youliang Tan, Luca Della Vedova, Charayaphan Nakorn Boon Han

 -- Morgan Quigley <morgan@openrobotics.org>  Sat, 12 Mar 2022 16:00:00 -0000

ros-humble-rmf-traffic-editor (1.4.0-1bookworm) bookworm; urgency=high

  * Feature/graph names and widths (#384 <https://github.com/open-rmf/rmf_traffic_editor/pull/384>)
    * Graph data structure: default lane widths and a step towards #378 <https://github.com/open-rmf/rmf_traffic_editor/pull/378>


=== debian/control ===
Source: ros-humble-rmf-traffic-editor
Section: misc
Priority: optional
Maintainer: Morgan Quigley <morgan@openrobotics.org>
Build-Depends: debhelper (>= 9.0.0), libceres-dev, libeigen3-dev, libgoogle-glog-dev, libproj-dev, libqt5concurrent5, libqt5widgets5, libyaml-cpp-dev, qtbase5-dev, ros-humble-ament-cmake, ros-humble-ament-cmake-uncrustify <!nocheck>, ros-humble-ament-index-cpp, ros-humble-rmf-utils, ros-humble-ros-workspace
Homepage: 
Standards-Version: 3.9.2

Package: ros-humble-rmf-traffic-editor
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libceres-dev, libgoogle-glog-dev, libproj-dev, ros-humble-ros-workspace
Description: traffic editor

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/humble/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG
ifneq ($(filter nocheck,$(DEB_BUILD_OPTIONS)),)
	BUILD_TESTING_ARG=-DBUILD_TESTING=OFF
endif

DEB_HOST_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)

%:
	dh $@ -v --buildsystem=cmake --builddirectory=.obj-$(DEB_HOST_GNU_TYPE)

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/humble/setup.sh" ]; then . "/opt/ros/humble/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/humble" \
		-DAMENT_PREFIX_PATH="/opt/ros/humble" \
		-DCMAKE_PREFIX_PATH="/opt/ros/humble" \
		$(BUILD_TESTING_ARG)

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/humble/setup.sh" ]; then . "/opt/ros/humble/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/humble/setup.sh" ]; then . "/opt/ros/humble/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/humble/setup.sh" ]; then . "/opt/ros/humble/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-humble-rmf-traffic-editor//opt/ros/humble/lib/:$(CURDIR)/debian/ros-humble-rmf-traffic-editor//opt/ros/humble/opt/rmf_traffic_editor/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/humble/setup.sh" ]; then . "/opt/ros/humble/setup.sh"; fi && \
	dh_auto_install
